]> git.ipfire.org Git - thirdparty/dracut.git/blobdiff - 51-dracut-rescue.install
squash: unsquash the root image instead of mounting it on shutdown
[thirdparty/dracut.git] / 51-dracut-rescue.install
index e5781d35033eca394b59ab8f79747a71b301eb5c..ef8afac18899c21faf465b562a0f2981b30d8241 100755 (executable)
-#!/bin/sh
-# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
-# ex: ts=8 sw=4 sts=4 et filetype=sh
+#!/bin/bash
 
 export LANG=C
 
 COMMAND="$1"
 KERNEL_VERSION="$2"
-BOOT_DIR_ABS="$3"
-BOOT_DIR="${3#/boot}"
+BOOT_DIR_ABS="${3%/*}/0-rescue"
+KERNEL_IMAGE="$4"
+
+
+dropindirs_sort()
+{
+    suffix=$1; shift
+    args=("$@")
+    files=$(
+        while (( $# > 0 )); do
+            for i in ${1}/*${suffix}; do
+                [[ -f $i ]] && echo ${i##*/}
+            done
+            shift
+        done | sort -Vu
+    )
+
+    for f in $files; do
+        for d in "${args[@]}"; do
+            if [[ -f "$d/$f" ]]; then
+                echo "$d/$f"
+                continue 2
+            fi
+        done
+    done
+}
 
 [[ -f /etc/os-release ]] && . /etc/os-release
-[[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
+
+if [[ ${KERNEL_INSTALL_MACHINE_ID+x} ]]; then
+    MACHINE_ID=$KERNEL_INSTALL_MACHINE_ID
+elif [[ -f /etc/machine-id ]] ; then
+    read MACHINE_ID < /etc/machine-id
+fi
+
+if ! [[ $MACHINE_ID ]]; then
+    exit 0
+fi
+
 if [[ -f /etc/kernel/cmdline ]]; then
-    readarray -t BOOT_OPTIONS < /etc/kernel/cmdline
+    read -r -d '' -a BOOT_OPTIONS < /etc/kernel/cmdline
+elif [[ -f /usr/lib/kernel/cmdline ]]; then
+    read -r -d '' -a BOOT_OPTIONS < /usr/lib/kernel/cmdline
 fi
+
 if ! [[ "${BOOT_OPTIONS[@]}" ]]; then
-    readarray -t BOOT_OPTIONS < /proc/cmdline
+    read -r -d '' -a line < /proc/cmdline
+    for i in "${line[@]}"; do
+        [[ "${i#initrd=*}" != "$i" ]] && continue
+        BOOT_OPTIONS+=("$i")
+    done
 fi
-if ! [[ $BOOT_OPTIONS ]]; then
+
+if ! [[ ${BOOT_OPTIONS[*]} ]]; then
+    echo "Could not determine the kernel command line parameters." >&2
+    echo "Please specify the kernel command line in /etc/kernel/cmdline!" >&2
     exit 1
 fi
 
-LOADER_ENTRY="/boot/loader/entries/${MACHINE_ID}-00-${KERNEL_VERSION}-rescue.conf"
+if [[ -d "${BOOT_DIR_ABS%/*}" ]]; then
+    BOOT_DIR="/${MACHINE_ID}/0-rescue"
+    BOOT_ROOT=${BOOT_DIR_ABS%$BOOT_DIR}
+    LOADER_ENTRY="$BOOT_ROOT/loader/entries/${MACHINE_ID}-0-rescue.conf"
+    KERNEL="linux"
+    INITRD="initrd"
+else
+    BLS_DIR="/boot/loader/entries"
+    BOOT_DIR_ABS="/boot"
+    LOADER_ENTRY="$BLS_DIR/${MACHINE_ID}-0-rescue.conf"
+    KERNEL="vmlinuz-0-rescue-${MACHINE_ID}"
+    INITRD="initramfs-0-rescue-${MACHINE_ID}.img"
+fi
 
 ret=0
 
 case "$COMMAND" in
     add)
-        for i in "/boot/loader/entries/${MACHINE_ID}-00-"*"-rescue.conf"; do
-            [[ -f $i ]] && exit 0
+        [[ -f "$LOADER_ENTRY" ]] && [[ -f "$BOOT_DIR_ABS/$KERNEL" ]] \
+            && [[ -f "$BOOT_DIR_ABS/$INITRD" ]] && exit 0
+
+        # source our config dir
+        for f in $(dropindirs_sort ".conf" "/etc/dracut.conf.d" "/usr/lib/dracut/dracut.conf.d"); do
+            [[ -e $f ]] && . "$f"
         done
 
-       dracut --no-hostonly  -a "rescue" "$3"/initrd-rescue "$2"
-        ((ret+=$?))
+        [[ $dracut_rescue_image != "yes" ]] && exit 0
 
-        {
-            echo "title      $PRETTY_NAME - Rescue Image"
-            echo "version    $KERNEL_VERSION"
-            echo "machine-id $MACHINE_ID"
-            echo "options    ${BOOT_OPTIONS[@]} rd.auto=1"
-            echo "linux      $BOOT_DIR/linux"
-            echo "initrd     $BOOT_DIR/initrd-rescue"
-        } > $LOADER_ENTRY
-        ((ret+=$?))
+        [[ -d "$BOOT_DIR_ABS" ]] || mkdir -p "$BOOT_DIR_ABS"
+
+        if ! cp --reflink=auto "$KERNEL_IMAGE" "$BOOT_DIR_ABS/$KERNEL"; then
+            echo "Can't copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/$KERNEL'!" >&2
+        fi
 
-        if (( $ret == 0 )); then
-            command -v yumdb &>/dev/null && \
-                yumdb set installonly keep kernel-$KERNEL_VERSION >/dev/null
+        if [[ ! -f "$BOOT_DIR_ABS/$INITRD" ]]; then
+            dracut -f --no-hostonly -a "rescue" "$BOOT_DIR_ABS/$INITRD" "$KERNEL_VERSION"
+            ((ret+=$?))
         fi
 
+        if [[ "${BOOT_DIR_ABS}" != "/boot" ]]; then
+            {
+                echo "title      $PRETTY_NAME - Rescue Image"
+                echo "version    $KERNEL_VERSION"
+                echo "machine-id $MACHINE_ID"
+                echo "options    ${BOOT_OPTIONS[@]} rd.auto=1"
+                echo "linux      $BOOT_DIR/linux"
+                echo "initrd     $BOOT_DIR/initrd"
+            } > $LOADER_ENTRY
+        else
+            cp -aT "${KERNEL_IMAGE%/*}/bls.conf" $LOADER_ENTRY
+            sed -i 's/'$KERNEL_VERSION'/0-rescue-'${MACHINE_ID}'/' $LOADER_ENTRY
+        fi
+
+        ((ret+=$?))
         ;;
 
     remove)
-        [[ -f $LOADER_ENTRY ]] || exit 0
-
-        rm -f "$LOADER_ENTRY" "$3"/initrd-rescue
+        exit 0
         ;;
 
     *)
@@ -62,6 +128,4 @@ case "$COMMAND" in
         ret=1;;
 esac
 
-((ret+=$?))
-
 exit $ret